export function pack(key, value, encryption) {
    if (value === undefined || value === null) {
        return null;
    }
    return `s:${encryption.verifier.sign(value, undefined, key)}`;
}
export function canUnpack(signedValue) {
    return typeof signedValue === 'string' && signedValue.substring(0, 2) === 's:';
}
export function unpack(key, signedValue, encryption) {
    const value = signedValue.slice(2);
    if (!value) {
        return null;
    }
    return encryption.verifier.unsign(value, key);
}
