import type { Logger } from '@adonisjs/logger';
import { Macroable } from '@poppinss/macroable';
import type { Request } from '../request.js';
import type { Response } from '../response.js';
import type { StoreRouteNode } from '../types/route.js';
export declare class HttpContext extends Macroable {
    request: Request;
    response: Response;
    logger: Logger;
    static get usingAsyncLocalStorage(): boolean;
    static get(): HttpContext | null;
    static getOrFail(): HttpContext;
    static runOutsideContext<T>(callback: (...args: any[]) => T, ...args: any[]): T;
    route?: StoreRouteNode;
    routeKey?: string;
    params: Record<string, any>;
    subdomains: Record<string, any>;
    constructor(request: Request, response: Response, logger: Logger);
    inspect(): string;
}
