import { Macroable } from '@poppinss/macroable';
import type { MiddlewareStore } from '../middleware/store.js';
import type { LazyImport, UnWrapLazyImport } from '../types/base.js';
import type { RouteMatcher } from '../types/route.js';
import type { GetMiddlewareArgs, MiddlewareAsClass, MiddlewareFn } from '../types/middleware.js';
import { Route } from './route.js';
import { BriskRoute } from './brisk.js';
import { RouteResource } from './resource.js';
export declare class RouteGroup<NamedMiddleware extends Record<string, LazyImport<MiddlewareAsClass>> = any> extends Macroable {
    #private;
    routes: (Route | RouteGroup | RouteResource | BriskRoute)[];
    constructor(routes: (Route | RouteGroup | RouteResource | BriskRoute)[], middlewareStore: MiddlewareStore<NamedMiddleware>);
    where(param: string, matcher: RouteMatcher | string | RegExp): this;
    prefix(prefix: string): this;
    domain(domain: string): this;
    as(name: string): this;
    middleware<Name extends keyof NamedMiddleware>(middleware: Name, ...args: GetMiddlewareArgs<UnWrapLazyImport<NamedMiddleware[Name]>>): this;
    middleware(middleware: MiddlewareFn): this;
}
