import type { Encryption } from '@adonisjs/encryption';
import type { Qs } from '../../qs.js';
import type { RouteFinder } from './route_finder.js';
export declare class UrlBuilder {
    #private;
    constructor(encryption: Encryption, routeFinder: RouteFinder, qsParser: Qs);
    prefixUrl(url: string): this;
    disableRouteLookup(): this;
    qs(queryString?: Record<string, any>): this;
    params(params?: any[] | Record<string, any>): this;
    make(identifier: string): string;
    makeSigned(identifier: string, options?: {
        expiresIn?: string | number;
        purpose?: string;
    }): string;
}
