import { RouteNotFoundException } from '../../exceptions/route_not_found.js';
export function finalHandler(router, resolver, ctx) {
    return function () {
        const url = ctx.request.url();
        const method = ctx.request.method();
        const hostname = router.usingDomains ? ctx.request.hostname() : undefined;
        const route = router.match(url, method, hostname);
        if (route) {
            ctx.params = route.params;
            ctx.subdomains = route.subdomains;
            ctx.route = route.route;
            ctx.routeKey = route.routeKey;
            return route.route.execute(route.route, resolver, ctx);
        }
        throw new RouteNotFoundException(`Cannot ${method}:${url}`);
    };
}
