/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
import type { Encryption } from '@adonisjs/encryption';
import type { Application } from '@adonisjs/application';
import type { Server as HttpsServer } from 'node:https';
import type { ServerResponse, IncomingMessage, Server as HttpServer } from 'node:http';
import type { LazyImport } from '../types/base.js';
import type { MiddlewareAsClass } from '../types/middleware.js';
import type { ErrorHandlerAsAClass, ServerConfig } from '../types/server.js';
import { Router } from '../router/main.js';
export declare class Server<NamedMiddleware extends Record<string, LazyImport<MiddlewareAsClass>> = any> {
    #private;
    get usingAsyncLocalStorage(): boolean;
    constructor(app: Application<any, any, any>, encryption: Encryption, config: ServerConfig);
    use(serverMiddleware: LazyImport<MiddlewareAsClass>[], routerMiddleware: LazyImport<MiddlewareAsClass>[], namedMiddleware: NamedMiddleware): this;
    errorHandler(handler: LazyImport<ErrorHandlerAsAClass>): this;
    boot(): Promise<void>;
    setNodeServer(server: HttpServer | HttpsServer): void;
    close(): Promise<void>;
    getNodeServer(): HttpServer<typeof IncomingMessage, typeof ServerResponse> | HttpsServer<typeof IncomingMessage, typeof ServerResponse> | undefined;
    getRouter(): Router<any> | undefined;
    handle(req: IncomingMessage, res: ServerResponse): Promise<any>;
}
