/// <reference types="node" resolution-mode="require"/>
/// <reference types="node" resolution-mode="require"/>
export type CookieOptions = {
    domain: string;
    expires: Date | (() => Date);
    httpOnly: boolean;
    maxAge: number | string;
    path: string;
    sameSite: boolean | 'lax' | 'none' | 'strict';
    secure: boolean;
};
export type CastableHeader = string | number | boolean | string[] | number[] | boolean[];
export type ResponseConfig = {
    etag: boolean;
    jsonpCallbackName: string;
    cookie: Partial<CookieOptions>;
};
export type ResponseStream = NodeJS.ReadStream | NodeJS.ReadWriteStream | NodeJS.ReadableStream;
